; attract.s
; demonstrates how to play LJ65

;;; Copyright (C) 2009 Damian Yerrick
;
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 3
;   of the License, or (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to 
;     Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;     Boston, MA  02111-1307, USA.
;
;   Visit http://www.pineight.com/ for more information.

.export attract_rand, attract_vblank, attract_run, attract_init, attract_pads
.importzp attractDataPtr, attractCursor, dirty_bottom, state_timer
.importzp sprite_index, rand_history, reset_time_hi, reset_time_lo
.importzp next_piece, cur_state, piece_yspeed, garbage_enabled, cur_flip
.importzp cur_keys, new_keys
.importzp REPEAT_DELAY, STATE_CHECK_LINES
.import palbuf, random

OAM = $200
PPUDATA = $2007
PPUADDR = $2006


.segment "RODATA"
attractPieces:
  .byt 5,1,0,6,3,4,2  ; TJIZOSL
  .byt 5,4,3,2,1,0,6  ; TSOLJIZ
  .byt 1,5,3,0,$FF    ; JTO, (unused) I, terminator
attractDataStart:
  .byt "PIECES MADE",$0A
  .byt "OF FOUR",$0A
  .byt "BLOCKS ARE",$0A
  .byt "FALLING INTO",$0A
  .byt "THE WELL.",$02,$02,$0C
  .byt "USE THE",$0A
  .byt "CONTROL PAD",$0A
  .byt "TO MOVE THEM",$0A
  .byt "SIDEWAYS OR",$0A
  .byt "MAKE THEM",$0A
  .byt "FALL FASTER.",$16,$16,$01,$17,$17,$17,$01,$1E,$01,$1D,$03,$0C
  .byt "PRESS UP TO",$0A
  .byt "SLAM A PIECE",$0A
  .byt "STRAIGHT TO",$0A
  .byt "THE FLOOR.",$17,$17,$01,$16,$16,$01,$14,$0C
  .byt "BLOCKS THAT",$0A
  .byt "FORM A LINE",$0A
  .byt "ACROSS THE",$0A
  .byt "WELL WITHOUT",$0A
  .byt "GAPS WILL",$0A
  .byt "DISAPPEAR,",$01,$17,$01,$1F,$01,$14,$0C
  .byt "MAKING ROOM",$0A
  .byt "FOR MORE",$0A
  .byt "PIECES.",$02,$02,$0C
  .byt "PRESS THE B",$0A
  .byt "OR A BUTTON",$0A
  .byt "TO TURN THE",$0A
  .byt "PIECE BY 90",$0A
  .byt "DEGREES.",$11,$01,$11,$01,$11,$01,$10,$01,$10,$16,$01,$14,$0C
  .byt "BUT YOU",$0A
  .byt "CAN'T TURN",$0A
  .byt "THE YELLOW",$0A
  .byt "SQUARE ONES.",$01,$10,$01,$10,$10,$10,$02,$14,$0C
  .byt "AFTER EACH",$0A
  .byt "PIECE LANDS,",$0A
  .byt "YOU HAVE A",$0A
  .byt "SPLIT SECOND",$0A
  .byt "TO SLIDE IT",$0A
  .byt "INTO PLACE,",$02,$1D,$17,$03,$0C
  .byt "EVEN IF IT'S",$0A
  .byt "UNDER AN",$0A
  .byt "OVERHANG.",$1F,$01,$10,$16,$02,$1D,$16,$03,$0C
  .byt "THE GHOST",$0A
  .byt "MARKER SHOWS",$0A
  .byt "WHERE A",$0A
  .byt "PIECE WILL",$0A
  .byt "LAND.",$01,$10,$1E,$01,$14,$0C
  .byt "TRY TO MAKE",$0A
  .byt "MORE THAN",$0A
  .byt "ONE LINE",$0A
  .byt "AT ONCE FOR",$0A
  .byt "MORE POINTS.",$01,$1F,$11,$01,$14,$0C
  .byt "IT'S MORE",$0A
  .byt "CHALLENGING,",$0A
  .byt "BUT IT",$0A
  .byt "PAYS OFF.",$01,$1E,$17,$01,$14,$0C
  .byt "THE L-SHAPED",$0A
  .byt "PIECE CLEARS",$0A
  .byt "THREE LINES.",$01,$0A,$11,$1F,$01,$14
  .byt "CAN YOU MAKE",$0A
  .byt "MORE???",$02,$02,$0C
  .byt "HOLES",$0A
  .byt "ARE BAD.",$02,$11,$1F,$14,$0A
  .byt "LINES WITH",$0A
  .byt "HOLES WON'T",$0A
  .byt "CLEAR.",$0A,$01,$1E,$1D,$03,$0C
  .byt "AND YOU",$0A
  .byt "DON'T WANT",$0A
  .byt "TO FILL THE",$0A
  .byt "WELL TO",$0A
  .byt "THE TOP.",$10,$01,$1F,$14,$01,$0C
  .byt "BUT YOU CAN",$0A
  .byt "EXPOSE HOLES",$0A
  .byt "BY CLEARING",$0A
  .byt "LINES.",$11,$17,$1D,$03,$0C
  .byt "YOU CAN TURN",$0A
  .byt "PIECES IN A",$0A
  .byt "TIGHT SPACE.",$1F,$16,$01,$11,$02,$1D,$11,$03,$0C
  .byt "NOW YOU'RE",$0A
  .byt "GETTING IT.",$02,$0A,$0A
  .byt "GOOD LUCK!",$01,$17,$17,$01,$14,$00

.segment "CODE"
.proc attract_init
  lda #<attractDataStart
  sta attractDataPtr
  lda #>attractDataStart
  sta attractDataPtr+1
  lda #22
  sta dirty_bottom
  lda #0
  sta rand_history
  sta state_timer
  sta cur_flip
  sta garbage_enabled
  sta piece_yspeed+1
  lda #$21
  sta attractCursor+1
  lda #$23
  sta attractCursor
  rts
.endproc

;;
; Gets the next piece in the predetermined sequence used
; by attract mode.  If no pieces remain, returns to title screen.
.proc attract_rand
  ldx rand_history
  lda attractPieces,x
  inc rand_history
  sta next_piece+1
  rts
.endproc


;;
; Updates the speech bubble in attract mode.
;
.proc attract_vblank

  ; Don't copy anything if 2P playfield is dirty.  There isn't
  ; enough time in the NTSC vblank to both copy player 2's field
  ; and clear a line of the speech bubble
  lda dirty_bottom+1
  cmp #20
  bcs :+
    rts
  :

  ; cur_flip holds the current control character;
  ; don't copy anything until we're done handling it.
  lda cur_flip
  bne notPrintable

  ; Don't copy a character if we're pointed at a
  ; control character.
  ldy #0
  lda (attractDataPtr),y
  cmp #$20
  bcc notPrintable
    ldx attractCursor+1
    stx PPUADDR
    ldx attractCursor
    inc attractCursor
    stx PPUADDR
    sta PPUDATA
    inc attractDataPtr
    bne :+
      inc attractDataPtr+1
    :
    rts
  notPrintable:

  lda cur_flip
  cmp #$0C
  bne notFormfeed
    ldx attractCursor+1
    stx PPUADDR
    ldx attractCursor
    inc attractCursor
    stx PPUADDR
    ldx #6
    lda #0
    loop:
      sta PPUDATA
      sta PPUDATA
      dex
      bne loop
    lda #$E0
    and attractCursor
    clc
    adc #$23
    sta attractCursor
    dec state_timer
    bne :+
      lda #0
      sta cur_flip
      lda #$23
      sta attractCursor
    :
    rts
  notFormfeed:
  rts
.endproc

.proc attract_sprite
  tileY = 0
  tileNo = 1
  baseX = 2
  tileX = 3
  leftInRow = 4

  lda #$93
  sta tileNo
  lda #127
  sta tileY
  lda #72
  sta baseX

  ldx sprite_index
  rowloop:
    lda baseX
    sta tileX
    lda tileNo
    cmp #$96
    lda #0
    adc #1
    sta leftInRow
    tileloop:
      lda tileY
      sta OAM,x
      sta OAM+4,x
      lda tileNo
      inc tileNo
      sta OAM+1,x
      sta OAM+5,x
      lda #0
      sta OAM+2,x
      lda #$40
      sta OAM+6,x
      lda tileX
      sta OAM+3,x
      clc
      adc #8
      sta tileX
      lda baseX
      asl a
      sec
      sbc tileX
      sta OAM+7,x
      txa
      clc
      adc #8
      tax

      dec leftInRow
      bne tileloop
    lda tileY
    clc
    adc #8
    sta tileY
    lda tileNo
    cmp #$A0
    bcc rowloop
  stx sprite_index
  lda #$02
  sta palbuf+17
  lda #$27
  sta palbuf+18
  lda #$30
  sta palbuf+19
  rts
.endproc


.proc attract_run
  jsr attract_sprite

  ldy state_timer
  beq state_timer_ready
    lda cur_flip
    bne known_rts
    dec state_timer
    jmp known_rts
  state_timer_ready:

  ; look for attract commands
  lda (attractDataPtr),y
  cmp #$20
  bcs known_rts  ; don't handle printable

  cmp #$10
  bcc not_pad

    ; In bytecode:
    ; $10-$17: short press (1/2 DAS delay)
    ; $18-$1F: long press (2x DAS delay)
    tay
    ldx #REPEAT_DELAY / 2
    and #$08
    beq :+
      ldx #REPEAT_DELAY * 2
    :
    stx state_timer

    ; In cur_flip:
    ; $10-$17: Not first frame of press
    ; $18-$1F: First frame of press
    tya
    ora #$18
    sta cur_flip
    jmp skip_byte
  not_pad:

  cmp #$01
  bne not_shortwait
    lda #REPEAT_DELAY*5/2
    sta state_timer
    jmp skip_byte
  not_shortwait:

  cmp #$02
  bne not_longwait
    lda #REPEAT_DELAY*15/2
    sta state_timer
    jmp skip_byte
  not_longwait:

  cmp #$03
  bne not_lockwait
    lda cur_state+1
    cmp #STATE_CHECK_LINES
    bne known_rts
    jmp skip_byte
  not_lockwait:

  cmp #$0A
  bne not_newline
    lda #$E0
    and attractCursor
    clc
    adc #$23
    sta attractCursor
    jmp skip_byte
  not_newline:

  cmp #$0C
  bne known_rts
    sta cur_flip
    lda #6
    sta state_timer
    lda #$23
    sta attractCursor
    jmp skip_byte

  skip_byte:
    inc attractDataPtr
    bne :+
      inc attractDataPtr+1
    :

  known_rts:
  rts
.endproc

.proc attract_pads

  ; clear out 2P keypresses
  lda #%00110000
  and cur_keys+1
  sta cur_keys+1
  and new_keys+1
  sta new_keys+1

  ; is an attract mode keypress scheduled?
  lda cur_flip
  and #$10
  cmp #$10
  beq :+
    rts
  :

  ; decode button ($10 -> $80; $11 -> $40, ..., $17 -> $01)
  lda cur_flip
  and #$07
  tax
  lda #0
  sec
  shiftLoop:
    ror a
    dex
    bpl shiftLoop
  tax

  ; write to new keys
  ora cur_keys+1
  sta cur_keys+1
  lda cur_flip
  and #$08
  beq notFirstFrame
    eor cur_flip
    sta cur_flip
    txa
    ora new_keys+1
    sta new_keys+1
  notFirstFrame:

  ; count down a frame
  dec state_timer
  bne notExpired
    lda #0
    sta cur_flip
    ldy #2
    jsr random
    and #$03
    ora #$04
    sta state_timer
  notExpired:
  rts
.endproc