.include "src/musicseq.h"

.segment "RODATA"

musicPatternTable:
  ; patterns 0-4: new melody
  .addr newmelody_sq1, newmelody_melody, newmelody_bass, newmelody_drum
  .addr newmelody_tri2
  .addr lmia_notes

drumSFX:
  .byt 10, 9
  
instrumentTable:
  ; first byte: initial duty/vol
  ; second byte: volume decrease every 16 frames
  ; third byte:
  ; bit 7: cut note if half a row remains
  .byt $09, 8, 0, 0  ; new melody "ukulele"
  .byt $89, 4, 0, 0  ; new melody "stereotypical nes"
  .byt $07, 0, $80, 0  ; lmia part 1 string
  .byt $49, 2, $80, 0  ; lmia part 2 piano
  .byt $89, 0, $80, 0  ; lmia part 3 tri

songTable:
  .addr newmelody_conductor
  .addr lmia_conductor

;____________________________________________________________________
; NEW MELODY: "Tetris New Melody" (OCRemoved) without Korobeiniki

newmelody_conductor:
  .byt CON_SETTEMPO+(>300), <300
  .byt CON_PLAYPAT+1, 0, 3, 0
  .byt CON_WAITROWS, 31
  .byt CON_PLAYPAT+0, 0, 3, 0
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_WAITROWS, 31
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_WAITROWS, 63
  .byt CON_SEGNO
  .byt CON_SETTEMPO+(>300), <300
  .byt CON_PLAYPAT+0, 0, 3, 0
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_PLAYPAT+2, 2, 19, 1
  .byt CON_PLAYPAT+3, 3, 0, 0
  .byt CON_WAITROWS, 31
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_PLAYPAT+2, 2, 19, 1
  .byt CON_PLAYPAT+3, 3, 0, 0
  .byt CON_WAITROWS, 95
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_PLAYPAT+2, 2, 19, 1
  .byt CON_PLAYPAT+3, 3, 0, 0
  .byt CON_WAITROWS, 63
  .byt CON_PLAYPAT+2, 4, 36, 1
  .byt CON_PLAYPAT+3, -1, 0, 0
  .byt CON_WAITROWS, 31
  .byt CON_LOOPPAT+1, 1, 27, 1
  .byt CON_WAITROWS, 63
  .byt CON_DALSEGNO


newmelody_sq1:
  .byt  9*8, 21*8, 26*8,  9*8, 21*8, 26*8, 25*8+4
  .byt 12*8, 24*8,  7*8, 19*8, 255
  
newmelody_bass:
  .byt  5*8, 5*8, 8*8, 5*8,26*8, 5*8, 8*8, 5*8
  .byt 26*8, 5*8, 8*8, 5*8, 8*8+1,    5*8, 8*8
  .byt  3*8, 3*8, 8*8, 3*8,26*8, 3*8, 8*8, 2*8
  .byt 26*8, 2*8, 8*8, 2*8, 0*8+1,    0*8, 3*8
  .byt  5*8, 5*8, 5*8, 5*8, 5*8+1,    5*8, 5*8
  .byt  3*8, 3*8, 3*8, 3*8, 3*8+1,    3*8, 3*8
  .byt  2*8, 2*8, 2*8, 2*8, 2*8+1,    2*8, 2*8
  .byt  0*8, 0*8, 0*8, 0*8, 0*8+1,    0*8, 0*8, 255

newmelody_tri2:
  .byt 5*8+1, 5*8+1, 5*8+3, 3*8+1, 3*8+1, 3*8+3
  .byt 2*8+1, 2*8+1, 2*8+3, 0*8+1, 0*8+1, 0*8+3, 255

newmelody_melody:
  .byt  9*8,21*8,16*8,26*8,14*8,16*8,17*8,26*8
  .byt 16*8,14*8,12*8,14*8,16*8,12*8,11*8,12*8
  .byt  9*8,21*8,16*8,26*8,14*8,16*8,17*8,26*8
  .byt 16*8,14*8,12*8,14*8,11*8,12*8,20*8,21*8
  .byt 26*8,14*8,17*8,14*8,21*8+1,   19*8,17*8
  .byt 19*8+2,   17*8,16*8+3
  .byt 14*8+1,   14*8,16*8,17*8+1,   16*8,14*8
  .byt 16*8+1,   12*8+1,   12*8+1,    9*8+1,   255
  
newmelody_drum:
  .byt 0*8,0*8,1*8,0*8,0*8,1*8,0*8,0*8
  .byt 0*8,0*8,1*8,0*8,0*8,1*8,0*8,0*8
  .byt 0*8,0*8,1*8,0*8,0*8,1*8,0*8,0*8
  .byt 0*8,0*8,1*8,0*8,0*8,1*8,0*8,0*8
  .byt 0*8+2,      0*8,1*8+1,  0*8,1*8+1
  .byt     1*8,0*8+1,  1*8+1,  1*8+1
  .byt 0*8+2,      0*8,1*8+1,  0*8,1*8+1
  .byt     1*8,0*8+1,  1*8+1,  1*8+1,255


;____________________________________________________________________
; LECK MICH IM ARSCH: Canon by Wolfgang Amadeus Mozart (K.231)

lmia_conductor:
  .byt CON_SETTEMPO+(>300), <300
  .byt CON_PLAYPAT+1, 5, 25, 2
  .byt CON_WAITROWS, 31
  .byt CON_PLAYPAT+0, 5, 25, 3
  .byt CON_WAITROWS, 31
  .byt CON_PLAYPAT+2, 5, 25, 4
  .byt CON_SEGNO
  .byt CON_WAITROWS, 95
  .byt CON_DALSEGNO

lmia_notes:
  ; 1
  .byt N_CH+D_2, N_DH+D_2, N_B+D_2, N_CH+D_2
  ; 5
  .byt REST+D_4, N_CH+D_2, N_B+D_4
  .byt REST+D_4, N_FH+D_2, N_EH+D_4
  ; 9
  .byt N_EH+D_4, N_GH+D_4, N_FH+D_4, N_DH+D_4
  .byt N_GH+D_4, N_G+D_4, REST+D_4, N_CH+D_8, N_B+D_8
  ; 13
  .byt N_A+D_8, N_G+D_8, N_F+D_8, N_E+D_8
  .byt N_D+D_8, N_D+D_8, N_G+D_8, N_A+D_8
  .byt N_G+D_8, N_F+D_8, N_E+D_8, N_D+D_8
  .byt N_C+D_8, N_GH, N_GH, N_GH, N_GH, N_GH, N_GH
  ; 17
  .byt N_GH+D_8, N_CH+D_8, N_CH+D_4
  .byt REST+D_8, N_FH, N_FH, N_FH, N_FH, N_FH, N_FH
  .byt N_FH+D_8, N_B+D_8, N_B+D_4
  .byt REST+D_8, N_CH, N_DH, N_EH, N_FH, N_GH+D_8
  ; 21
  .byt N_A+D_8, N_AH, N_AH, N_AH, N_AH, N_AH, N_AH
  .byt N_AH+D_8, N_DH+D_8, N_DH+D_4
  .byt REST+D_8, N_GH, N_GH, N_GH, N_GH, N_GH, N_GH
  .byt N_GH+D_8, N_CH+D_8, N_CH+D_D8, REST
  .byt 255
