;   samples.s
;   DPCM sample handling code for LJ65
;

;;; Copyright (C) 2009 Damian Yerrick
;
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 3
;   of the License, or (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to 
;     Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;     Boston, MA  02111-1307, USA.
;
;   Visit http://www.pineight.com/ for more information.

.segment "CODE"
.global play_dmc


;;
; Plays a digital sample.
; A - bits 0-6: id number of sample
;     bit 7: if true, use rate in Y; otherwise, use sample's default rate
; Y - playback rate, if A bit 7 is set
play_dmc:
  asl a
  tax
  bcs @no_default_rate
    ldy dmctable+1,x
  @no_default_rate:
  sty $4010
  lda #$20
  sta $4011
  lda dmctable,x
  sta $4012
  eor #$ff
  clc
  adc dmctable+2,x
  asl a
  asl a
  sta $4013
  lda #$1f
  sta $4015
  rts

.segment "DMC"
four_lines:
  .incbin "obj/nes/4lines.dmc"
dmc_end:

.segment "RODATA"
.global dmctable

; byte 0: start address = 0xc000 + n/64
; byte 1: playback speed

dmctable:
  .byt  <(four_lines >> 6), $0e
  .byt  <(dmc_end    >> 6), $00

